package scouter;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import net.minecraft.client.Minecraft;
import net.minecraft.client.renderer.entity.Render;
import net.minecraft.client.settings.KeyBinding;
import net.minecraft.entity.Entity;
import net.minecraft.entity.EntityLiving;
import net.minecraft.src.ModLoader;
import net.minecraft.util.MovingObjectPosition;
import net.minecraft.world.World;

import org.lwjgl.input.Keyboard;


public class Scouter
{
	public final mod_Scouter mod;
	public final String modName = this.getClass().getSimpleName();
	public EntityScouter entity;
	public RenderScouter render;
	public String sightTexturePass = "/scouter/sight.png";
	public String circleTexturePass = "/scouter/circle.png";
	private World lastWorld = null;
	private boolean ctrl;
	private String[] modeName = {
		"Item",
		"Animal",
		"ID",
		"Type",
		"Scouter"
	};
	public EntityLiving targetEntity = null;
	public List<EntityLiving> lockonEntityList = new ArrayList<EntityLiving>();
	public List<MovingObjectPosition> lockonBlockList = new ArrayList<MovingObjectPosition>();
	public MovingObjectPosition targetBlock = null;
	public String enemy = null;
	public boolean addLockonEntity;
	public boolean addLockonBlock;
	public boolean looking;
	public int lockonId;
	public int lockonBlockIndex;
//	public int entityCountAll;
	public int entityCountMob;
	public int entityCountAnimal;
	public int entityCountItem;
	public int lockonColorInt;
	public long timer;
	public float tick;
	public float count;
	public float lockonColor_R;
	public float lockonColor_G;
	public float lockonColor_B;
	public float lockonColor_A;

	public Scouter(mod_Scouter mod)
	{
		this.mod = mod;
		render = new RenderScouter(this);
	}

	public String getVersion()
	{
		return "v3.2.1 [1.3.2]";
	}

	public void load()
	{
		KeyBinding[] keyBinding = new KeyBinding[]{
			new KeyBinding(Keyboard.getKeyName(mod_Scouter.cfg_Power) + " (Power)", mod_Scouter.cfg_Power),
			new KeyBinding(Keyboard.getKeyName(mod_Scouter.cfg_Control) + " (Control)", mod_Scouter.cfg_Control),
			new KeyBinding(Keyboard.getKeyName(mod_Scouter.cfg_ModeUp) + " (ModeUp)", mod_Scouter.cfg_ModeUp),
			new KeyBinding(Keyboard.getKeyName(mod_Scouter.cfg_ModeDown) + " (ModeDown)", mod_Scouter.cfg_ModeDown),
			new KeyBinding(Keyboard.getKeyName(mod_Scouter.cfg_RangeUp) + " (RangeUp)", mod_Scouter.cfg_RangeUp),
			new KeyBinding(Keyboard.getKeyName(mod_Scouter.cfg_RangeDown) + " (RangeDown)", mod_Scouter.cfg_RangeDown),
			new KeyBinding(Keyboard.getKeyName(mod_Scouter.cfg_Alert) + " (Alert)", mod_Scouter.cfg_Alert),
			new KeyBinding(Keyboard.getKeyName(mod_Scouter.cfg_Coordinate) + " (Coordinate)", mod_Scouter.cfg_Coordinate)
		};
		for(int i = 0; i < keyBinding.length; i++){
			ModLoader.registerKey(mod, keyBinding[i], true);
//			System.out.println(String.format("[" + modName + "] %s : [%d] %s", keyBinding[i], keyBinding[i].keyCode, keyBinding[i].keyDescription));
		}
		if(java.util.regex.Pattern.matches("0x\\w\\w\\w\\w\\w\\w\\w\\w", mod_Scouter.lockonColor))
		{
			long lockonColorLong = Long.decode(mod_Scouter.lockonColor);
			lockonColorInt = (int)lockonColorLong;
		} else
		{
			lockonColorInt = 0xcc66ff99;
		}
		lockonColor_A = ((lockonColorInt & 0xff000000) >>> 24) / 255.0F;
		lockonColor_R = ((lockonColorInt & 0x00ff0000) >> 16) / 255.0F;
		lockonColor_G = ((lockonColorInt & 0x0000ff00) >> 8) / 255.0F;
		lockonColor_B = ((lockonColorInt & 0x000000ff) >> 0) / 255.0F;
//		System.out.println("[" + modName + "] LockonColor : 0x" + Integer.toHexString(lockonColorInt));
		addRendererForFML();
		ModLoader.setInGameHook(mod, true, false);
	}

	private void addRendererForFML()
	{
		try
		{
			Class clazz = Class.forName("cpw.mods.fml.common.Loader");
			Map<Class<? extends Entity>, Render> renderers = new java.util.HashMap<Class<? extends Entity>, Render>();
			addRenderer(renderers);
			for(Entry<Class<? extends Entity>, Render> e : renderers.entrySet())
			{
				cpw.mods.fml.client.registry.RenderingRegistry.registerEntityRenderingHandler(e.getKey(), e.getValue());
			}
		}
		catch(ClassNotFoundException e)
		{
			System.out.println("[" + modName + "] ForgeModLoader not found. Use ModLoader.");
		}
		catch(Exception e)
		{
			e.printStackTrace();
		}
	}

	public void addRenderer(Map map)
	{
		map.put(EntityScouter.class, render);
	}

	public boolean onTickInGame(float f, Minecraft minecraft)
	{
		if(minecraft.theWorld != lastWorld)
		{
			entity = new EntityScouter(minecraft, minecraft.theWorld);
			entity.setPosition(minecraft.thePlayer.posX, minecraft.thePlayer.posY - minecraft.thePlayer.height, minecraft.thePlayer.posZ);
			minecraft.theWorld.spawnEntityInWorld(entity);
			lastWorld = minecraft.theWorld;
			addLockonBlock = false;
			addLockonEntity = false;
			lockonBlockIndex = 0;
			lockonBlockList.clear();
			targetBlock = null;
			lockonId = 0;
			lockonEntityList.clear();
			targetEntity = null;
			if(mod_Scouter.power)
			{
				setCount();
			}
			timer = System.currentTimeMillis();
		}
		tick = f;
		if(minecraft.currentScreen == null && !minecraft.gameSettings.hideGUI)
		{
			if(mod_Scouter.power)
			{
				if(mod_Scouter.lockon)
				{
					if(Keyboard.isKeyDown(mod_Scouter.cfg_Control))
					{
						if(mod_Scouter.lockonBlock)
						{
							if(targetBlock != null)
							{
								boolean flag = true;
								for(MovingObjectPosition temp : lockonBlockList)
								{
									if(temp.blockX == targetBlock.blockX && temp.blockY == targetBlock.blockY && temp.blockZ == targetBlock.blockZ)
									{
										flag = false;
									}
								}
								if(flag)
								{
									lockonBlockList.add(targetBlock);
									addLockonBlock = true;
								}
							}
						} else
						{
							if(targetEntity != null)
							{
								boolean flag = true;
								for(EntityLiving temp : lockonEntityList)
								{
									if(temp.entityId == targetEntity.entityId)
									{
										flag = false;
										break;
									}
								}
								if(flag)
								{
									lockonEntityList.add(targetEntity);
									addLockonEntity = true;
								}
							}
						}
					}
					if(ctrl && !Keyboard.getEventKeyState() && !Keyboard.isKeyDown(mod_Scouter.cfg_Control))
					{
						if(mod_Scouter.lockonBlock)
						{
							if(addLockonBlock)
							{
								lockonBlockIndex = lockonBlockList.size() - 1;
							} else
							{
								if(targetBlock != null)
								{
									if(!lockonBlockList.isEmpty())
									{
										for(int i = 0; i < lockonBlockList.size(); i++)
										{
											if(lockonBlockList.get(i).blockX == targetBlock.blockX && lockonBlockList.get(i).blockY == targetBlock.blockY && lockonBlockList.get(i).blockZ == targetBlock.blockZ)
											{
												lockonBlockList.remove(i);
												if(lockonBlockIndex > 0)
												{
													lockonBlockIndex--;
												} else
												{
													lockonBlockIndex = 0;
												}
												break;
											}
										}
									}
								} else
								{
									lockonBlockList.clear();
								}
							}
						} else
						{
							if(addLockonEntity)
							{
								if(lockonId == 0)
								{
									if(lockonEntityList.size() > 1)
									{
										lockonId = lockonEntityList.get(0).entityId;
									} else
									{
										if(targetEntity != null)
										{
											lockonId = targetEntity.entityId;
										}
									}
								}
							} else
							{
								if(!lockonEntityList.isEmpty())
								{
									boolean flag = true;
									if(lockonEntityList.contains(targetEntity) && looking)
									{
										if(lockonEntityList.size() >= 2)
										{
											int i = lockonEntityList.indexOf(targetEntity);
											int j = lockonEntityList.get(i).entityId;
											lockonEntityList.remove(i);
											if(lockonId == j)
											{
												lockonId = lockonEntityList.get(0).entityId;
												targetEntity = lockonEntityList.get(0);
											}
											flag = false;
										}
									}
									if(flag)
									{
										lockonEntityList.clear();
									}
								}
							}
						}
						addLockonBlock = false;
						addLockonEntity = false;
						ctrl = false;
					}
				}
				if(!minecraft.gameSettings.showDebugInfo)
				{
					if((mod_Scouter.lockon && !mod_Scouter.lockonBlock && targetEntity != null) || (mod_Scouter.lockonBlock && (targetBlock != null || !lockonBlockList.isEmpty())))
					{
						render.drawScouterTargetStatus(minecraft);
					}
					if(mod_Scouter.alert && enemy != null)
					{
						render.drawScouterAlert(minecraft);
					}
					if(mod_Scouter.coordinate)
					{
						render.drawScouterCoordinate(minecraft);
					}
				}
				if(count >= 0)
				{
					render.drawScouterStatus(minecraft, (mod_Scouter.lockon ? "LockOnMode" : "") + (mod_Scouter.lockonBlock ? "[+Block]" : ""), "Alert : " + (mod_Scouter.alert ? "ON" : "OFF"), String.format("Mode%d : %s [%d]", mod_Scouter.mode + 1, modeName[mod_Scouter.mode], mod_Scouter.range));
					count -= f;
				}
			} else
			{
				if(count >= 0)
				{
					render.drawScouterStatus(minecraft, "", "", "Scouter : OFF");
					count -= f;
				}
			}
		}
		return true;
	}

	public void keyboardEvent(KeyBinding keyBinding)
	{
		Minecraft minecraft = ModLoader.getMinecraftInstance();
		if(!keyBinding.isPressed() || minecraft.currentScreen != null || minecraft.gameSettings.hideGUI)
		{
			return;
		}
		if(keyBinding.keyCode == mod_Scouter.cfg_Power)
		{
			if(mod_Scouter.power)
			{
				if(mod_Scouter.lockon)
				{
					if(mod_Scouter.lockonBlock)
					{
						mod_Scouter.lockonBlock = false;
						mod_Scouter.lockon = false;
						mod_Scouter.power = false;
					} else
					{
						mod_Scouter.lockonBlock = true;
					}
				} else
				{
					mod_Scouter.lockon = true;
				}
			} else
			{
				mod_Scouter.power = true;
			}
			setCount();
		}
		ctrl = false;
		if(mod_Scouter.power)
		{
			if(keyBinding.keyCode == mod_Scouter.cfg_ModeUp)
			{
				if(Keyboard.isKeyDown(mod_Scouter.cfg_Control))
				{
					if(mod_Scouter.lockon)
					{
						if(mod_Scouter.lockonBlock)
						{
							if(!lockonBlockList.isEmpty())
							{
								if(lockonBlockIndex < lockonBlockList.size() - 1)
								{
									lockonBlockIndex++;
								} else
								{
									lockonBlockIndex = 0;
								}
							}
						} else
						{
							if(!lockonEntityList.isEmpty())
							{
								int lockonIndex;
								if(lockonEntityList.indexOf(targetEntity) == lockonEntityList.size() - 1)
								{
									lockonIndex = 0;
								} else
								{
									lockonIndex = lockonEntityList.indexOf(targetEntity);
								}
								for(int i = lockonIndex; i < lockonEntityList.size(); i++)
								{
									if(lockonEntityList.get(i).entityId != lockonId)
									{
										lockonId = lockonEntityList.get(i).entityId;
										targetEntity = lockonEntityList.get(i);
										break;
									}
								}
							}
						}
					}
				} else
				{
					if(mod_Scouter.mode < modeName.length - 1)
					{
						mod_Scouter.mode++;
						setCount();
					} else
					{
						mod_Scouter.mode = 0;
						setCount();
					}
				}
			}
			if(keyBinding.keyCode == mod_Scouter.cfg_ModeDown)
			{
				if(Keyboard.isKeyDown(mod_Scouter.cfg_Control))
				{
					if(mod_Scouter.lockon)
					{
						if(mod_Scouter.lockonBlock)
						{
							if(!lockonBlockList.isEmpty())
							{
								if(lockonBlockIndex > 0)
								{
									lockonBlockIndex--;
								} else
								{
									lockonBlockIndex = lockonBlockList.size() - 1;
								}
							}
						} else
						{
							if(!lockonEntityList.isEmpty())
							{
								int lockonIndex;
								if(lockonEntityList.indexOf(targetEntity) == 0)
								{
									lockonIndex = lockonEntityList.size() - 1;
								} else
								{
									lockonIndex = lockonEntityList.indexOf(targetEntity);
								}
								for(int i = lockonIndex; i >= 0; i--)
								{
									if(lockonEntityList.get(i).entityId != lockonId)
									{
										lockonId = lockonEntityList.get(i).entityId;
										targetEntity = lockonEntityList.get(i);
										break;
									}
								}
							}
						}
					}
				} else
				{
					if(mod_Scouter.mode > 0)
					{
						mod_Scouter.mode--;
						setCount();
					} else
					{
						mod_Scouter.mode = modeName.length - 1;
						setCount();
					}
				}
			}
			if(keyBinding.keyCode == mod_Scouter.cfg_RangeUp)
			{
				if(Keyboard.isKeyDown(mod_Scouter.cfg_Control))
				{
					if(mod_Scouter.range == 0)
					{
						mod_Scouter.range = 16;
						setCount();
					} else
					if(mod_Scouter.range < 32)
					{
						mod_Scouter.range += 16;
						setCount();
					} else
					if(mod_Scouter.range < 256)
					{
						if(mod_Scouter.range + 32 >= 256)
						{
							mod_Scouter.range = 256;
						} else
						{
							mod_Scouter.range += 32;
						}
						setCount();
					}
				}
			}
			if(keyBinding.keyCode == mod_Scouter.cfg_RangeDown)
			{
				if(Keyboard.isKeyDown(mod_Scouter.cfg_Control))
				{
					if(mod_Scouter.range > 32)
					{
						mod_Scouter.range -= 32;
						setCount();
					} else
					if(mod_Scouter.range > 16)
					{
						mod_Scouter.range -= 16;
						setCount();
					} else
					if(mod_Scouter.range > 0)
					{
						mod_Scouter.range = 0;
						setCount();
					}
				}
			}
			if(keyBinding.keyCode == mod_Scouter.cfg_Control)
			{
				ctrl = true;
			}
			if(keyBinding.keyCode == mod_Scouter.cfg_Alert)
			{
				//if(Keyboard.isKeyDown(mod_Scouter.cfg_Control))
				{
					if(mod_Scouter.alert)
					{
						mod_Scouter.alert = false;
					} else
					{
						mod_Scouter.alert = true;
					}
					setCount();
				}
			}
			if(keyBinding.keyCode == mod_Scouter.cfg_Coordinate)
			{
				//if(Keyboard.isKeyDown(mod_Scouter.cfg_Control))
				{
					if(mod_Scouter.coordinate)
					{
						mod_Scouter.coordinate = false;
					} else
					{
						mod_Scouter.coordinate = true;
					}
				}
			}
		}
	}

	private void setCount()
	{
		count = 200.0F;
	}
}
