package scouter;

import scouter.Scouter;
import net.minecraft.client.Minecraft;
import net.minecraft.client.settings.KeyBinding;
import net.minecraft.entity.Entity;
import net.minecraft.entity.EntityCreature;
import net.minecraft.entity.EntityLiving;
import net.minecraft.entity.ai.EntityAITaskEntry;
import net.minecraft.entity.ai.EntityAITasks;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.src.BaseMod;
import net.minecraft.src.MLProp;
import net.minecraft.src.ModLoader;

import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.util.ArrayList;
import java.util.List;

import cpw.mods.fml.common.ObfuscationReflectionHelper;

public class mod_Scouter extends BaseMod
{
	private String findPlayerToAttack = "func_70782_k";
	private String getDropItemId = "func_70633_aT";
	private final Scouter mod;

	public mod_Scouter()
	{
		mod = new Scouter(this);
	}

	@Override
	public String getVersion()
	{
		return mod.getVersion();
	}

	@Override
	public void load()
	{
		mod.load();
	}

	@Override
	public void addRenderer(java.util.Map map)
	{
		mod.addRenderer(map);
	}

	@Override
	public boolean onTickInGame(float f, Minecraft minecraft)
	{
		return mod.onTickInGame(f, minecraft);
	}
/*
	@Override
	public boolean onTickInGUI(float f, Minecraft minecraft, GuiScreen gui)
	{
		return mod.onTickInGUI(f, minecraft, gui);
	}
*/
	@Override
	public void keyboardEvent(KeyBinding keybinding)
	{
		mod.keyboardEvent(keybinding);
	}

	public List<String> getEntityAItasks(EntityLiving entityliving)
	{
		List<EntityAITaskEntry> tasks = new ArrayList<EntityAITaskEntry>();
		List<EntityAITaskEntry> targetTasks = new ArrayList<EntityAITaskEntry>();
		try
		{
			tasks = (ArrayList<EntityAITaskEntry>)ModLoader.getPrivateValue(EntityAITasks.class, entityliving.tasks, 1);//field_75780_b
			String[] fields = ObfuscationReflectionHelper.remapFieldNames("EntityLiving", "targetTasks");
			EntityAITasks t = (EntityAITasks)ModLoader.getPrivateValue(EntityLiving.class, entityliving, fields[0]);//"field_70715_bh", targetTasks
			targetTasks = (ArrayList<EntityAITaskEntry>)ModLoader.getPrivateValue(EntityAITasks.class, t, 1);//field_75780_b
		}
		catch(Exception e)
		{
			e.printStackTrace();
		}
		tasks.addAll(targetTasks);
		List<String> ai = new ArrayList<String>();
		int size = tasks.size();
		for(int i = 0; i < size; i++)
		{
			String s;
			s = tasks.get(i).action.getClass().getSimpleName().toString();
			if(this.getClass().getPackage() == null)
			{
				s = mod.render.entityAImap.get(s);
			} else
			{
				s = s.substring(8);
			}
			ai.add(s);
		}
		return ai;
	}

	public Entity findPlayerToAttack(EntityCreature entitycreature)
	{
		try {
			Method m = EntityCreature.class.getDeclaredMethod(findPlayerToAttack);//findPlayerToAttack
			m.setAccessible(true);
			return (Entity) m.invoke(entitycreature);
		} catch (NoSuchMethodException e) {
			findPlayerToAttack = "findPlayerToAttack";
			e.printStackTrace();
		} catch (SecurityException e) {
			// TODO ꂽ catch ubN
			e.printStackTrace();
		}
		catch (IllegalAccessException e) {
			// TODO ꂽ catch ubN
			e.printStackTrace();
		} catch (IllegalArgumentException e) {
			// TODO ꂽ catch ubN
			e.printStackTrace();
		} catch (InvocationTargetException e) {
			// TODO ꂽ catch ubN
			e.printStackTrace();
		}
		return null;
		//return entitycreature.findPlayerToAttack();
	}

	public int getDropItemId(EntityLiving entityliving)
	{
		try {
			Method m = EntityLiving.class.getDeclaredMethod(getDropItemId);//getDropItemId
			m.setAccessible(true);
			return (Integer) m.invoke(entityliving, new Object[]{});
		} catch (NoSuchMethodException e) {
			getDropItemId = "getDropItemId";
			e.printStackTrace();
		} catch (SecurityException e) {
			// TODO ꂽ catch ubN
			e.printStackTrace();
		}
		catch (IllegalAccessException e) {
			// TODO ꂽ catch ubN
			e.printStackTrace();
		} catch (IllegalArgumentException e) {
			// TODO ꂽ catch ubN
			e.printStackTrace();
		} catch (InvocationTargetException e) {
			// TODO ꂽ catch ubN
			e.printStackTrace();
		}
		return 0;
	}

	public int getExperiencePoints(EntityLiving entityliving, EntityPlayer entityplayer)
	{
		return entityliving.experienceValue;

	}

	@MLProp(info="[Power] true:ON / false:OFF", min = 0, max = 1, name = "power")
	public static boolean power = false;
	@MLProp(info="[LockonMode] true:ON / false:OFF", min = 0, max = 1, name = "lockon")
	public static boolean lockon = false;
	@MLProp(info="[LockonMode+Block] true:ON / false:OFF", min = 0, max = 1, name = "lockonBlock")
	public static boolean lockonBlock = false;
	@MLProp(info="[AlertDisplay] true:ON / false:OFF", min = 0, max = 1, name = "alert")
	public static boolean alert = false;
	@MLProp(info="[CoordinateDisplay] true:ON / false:OFF", min = 0, max = 1, name = "coordinate")
	public static boolean coordinate = false;
	@MLProp(info="[StartupMode] 0:Item / 1:Animal / 2:ID / 3:Type / 4:Scouter", min = 0, max = 4, name = "mode")
	public static int mode = 2;
	@MLProp(info="[ScanRange] 0 - 256", min = 0, max = 256, name = "range")
	public static int range = 64;
	@MLProp(info="[StringDisplayRange] 0 - 256", min = 0, max = 256, name = "stringDisplayRange")
	public static int stringDisplayRange = 64;
	@MLProp(info="[TargetStatusPosition] 0:Center / 1:UpperLeft / 2:LowerLeft / 3:UpperRight / 4:LowerRight", min = 0, max = 4, name = "targetStatusPosition")
	public static int targetStatusPosition = 4;
	@MLProp(info="[TargetStatusCustomCoordinateX] Difference from the current position", min = Integer.MIN_VALUE, max = Integer.MAX_VALUE, name = "targetStatus_X")
	public static int targetStatus_X = 0;
	@MLProp(info="[TargetStatusCustomCoordinateY] Difference from the current position", min = Integer.MIN_VALUE, max = Integer.MAX_VALUE, name = "targetStatus_Y")
	public static int targetStatus_Y = 0;
	@MLProp(info="[LockonColor] 0x[(Alpha)cc(Red)66(Green)ff(Blue)99]", min = Double.MIN_VALUE, max = Double.MAX_VALUE, name = "lockonColor")
	public static String lockonColor = "0xcc66ff99";

	@MLProp(info="F4 -> http://lwjgl.org/javadoc/constant-values.html#org.lwjgl.input.Keyboard.CHAR_NONE", min = 0, max = 256, name = "cfg_Power")
	public static int cfg_Power = 62;//F4
	@MLProp(info="L_Control", min = 0, max = 256, name = "cfg_Control")
	public static int cfg_Control = 29;//L_Control
	@MLProp(info="Right", min = 0, max = 256, name = "cfg_ModeUp")
	public static int cfg_ModeUp = 205;//Right
	@MLProp(info="Left", min = 0, max = 256, name = "cfg_ModeDown")
	public static int cfg_ModeDown = 203;//Left
	@MLProp(info="Up", min = 0, max = 256, name = "cfg_RangeUp")
	public static int cfg_RangeUp = 200;//Up
	@MLProp(info="Down", min = 0, max = 256, name = "cfg_RangeDown")
	public static int cfg_RangeDown = 208;//Down
	@MLProp(info="R_Control", min = 0, max = 256, name = "cfg_Alert")
	public static int cfg_Alert = 157;//R_Control
	@MLProp(info="R_Shift", min = 0, max = 256, name = "cfg_Coordinate")
	public static int cfg_Coordinate = 54;//R_Shift
}
